;AutoFTP Installation v1.0
;Written by Jeff Winn

!define MUI_PRODUCT "AutoFTP"
!define MUI_VERSION "1.0"

SetCompressor bzip2

!include "${NSISDIR}\Contrib\Modern UI\System.nsh"
;----------------------------------
;Configuration

  !define MUI_UI     "${NSISDIR}\Contrib\UIs\modern2.exe"
  !define MUI_ICON   "${NSISDIR}\contrib\Icons\setup.ico"
  !define MUI_UNICON "${NSISDIR}\Contrib\Icons\setup.ico"

  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_COMPONENTSPAGE
  !define MUI_DIRECTORYPAGE
  !define MUI_ABORTWARNING

  !define MUI_CUSTOMPAGECOMMANDS

  !define MUI_UNINSTALLER
  !define MUI_CONFIRMPAGE

  !define TEMP1 $R0
  !define TEMP2 $R1

  ;Language
  !insertmacro MUI_LANGUAGE "English"

  ;License page
  LicenseData "License.txt"

  OutFile "AutoFTP ${MUI_VERSION} Installer.exe"

  ;Install Options pages

    ;Header
    LangString TEXT_IO_TITLE ${LANG_ENGLISH} "User Registration Information"
    LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "Please enter user registration information below"

    ;Window Titles
    LangString TEXT_IO_PAGETITLE_A ${LANG_ENGLISH} "Enter your Name and Company:"

  ;Page Order
  !insertmacro MUI_PAGECOMMAND_WELCOME
  !insertmacro MUI_PAGECOMMAND_LICENSE
  Page custom SetCustomA ": Registration Information"
  !insertmacro MUI_PAGECOMMAND_COMPONENTS
  !insertmacro MUI_PAGECOMMAND_DIRECTORY
  !insertmacro MUI_PAGECOMMAND_INSTFILES

  InstallDir $PROGRAMFILES\AutoFTP
  InstallDirRegKey HKLM Software\AutoFTP ""

  SetOverwrite on

  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  ReserveFile "ioA.ini"

;-----------------------------------
;Modern UI System

!insertmacro MUI_SYSTEM

InstType "Full (w/Core and Help)"
InstType "Lite (w/o Help)"

;-----------------------------------
;Installer Sections

Section "AutoFTP Core Files (required)" SecCore
  SectionIn 1 RO
  SetOverwrite ifnewer

  SetOutPath $INSTDIR
  File "AutoFTP.exe"


  SetOutPath $SYSDIR
  File "WNCalendar.ocx"
  File "NotifyIcon.ocx"
  File "RemoteDialog.ocx"

  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP1} "ioA.ini" "Field 2" "Text"
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "ioA.ini" "Field 4" "Text"

  ;Register the OCX Controls
  RegDLL "$SYSDIR\WNCalendar.ocx"
  RegDLL "$SYSDIR\RemoteDialog.ocx"
  RegDLL "$SYSDIR\NotifyIcon.ocx"

  ;Write the Default Registry Values
  WriteRegStr HKLM "Software\AutoFTP" "Name" $R0
  WriteRegStr HKLM "Software\AutoFTP" "Company" $R1
  WriteRegStr HKLM "Software\AutoFTP" "Overwrite" "Prompt"
  WriteRegBin HKLM "Software\AutoFTP" "ASCII" 0000
  WriteRegBin HKLM "Software\AutoFTP" "Passive" 0000

  ;Write the autostart key for Windows\Run
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Run" "AutoFTP" "$INSTDIR\AutoFTP.exe"

  ;Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\AutoFTP" "DisplayName" "AutoFTP ${MUI_VERSION}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\AutoFTP" "UninstallString" "$INSTDIR\Uninstall.exe"

  ;Create UnInstaller
  WriteUninstaller "$INSTDIR\UnInstall.exe"

SectionEnd

Section "Help Files" SecHelp
  SectionIn 1 3
  File "Help\AutoFTP.chm"

SectionEnd

Section ""
  CreateDirectory "$SMPROGRAMS\AutoFTP"
  CreateShortCut "$SMPROGRAMS\AutoFTP\AutoFTP.lnk" "$INSTDIR\AutoFTP.exe" "/setup"
  CreateShortCut "$SMPROGRAMS\AutoFTP\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
SectionEnd

;------------------------------------
;Descriptions
!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecCore} "The core files required to use the AutoFTP program."
  !insertmacro MUI_DESCRIPTION_TEXT ${SecHelp} "Help files used by AutoFTP."
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END

;--------------------------------------
;Installer Functions

Function .onInit
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "ioA.ini"
FunctionEnd

Function SetCustomA
  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE)" "$(TEXT_IO_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY "ioA.ini"
FunctionEnd


;------------------------------------
;UnInstaller Section

Section "UnInstall"

  ;Remove the Program Directory Items
  Delete "$INSTDIR\*.*"

  ;Remove the start Menu Items
  Delete "$SMPROGRAMS\AutoFTP\*.*"
  RMDIR "$SMPROGRAMS\AutoFTP"

  ;Remove the OCX files that were used
  Delete "$SYSDIR\WNCalendar.ocx"
  Delete "$SYSDIR\NotifyIcon.ocx"
  Delete "$SYSDIR\RemoteDialog.ocx"

  DeleteRegKey HKLM "Software\AutoFTP"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\AutoFTP"
  DeleteRegValue HKLM "Software\Microsoft\Windows\CurrentVersion\Run" "AutoFTP"

  ;Remove the Registered OCXs
  UnRegDLL "$SYSDIR\NotifyIcon.ocx"
  UnRegDLL "$SYSDIR\WNCalendar.ocx"
  UnRegDLL "$SYSDIR\RemoteDialog.ocx"

  RMDIR "$INSTDIR"

  !insertmacro MUI_UNFINISHHEADER

SectionEnd