Attribute VB_Name = "modMain"
Public mFTP As cFTP
Public CurrentDirectory As String
Public Registry As RegistryHandler

Public Const vbCancelString = "~!~!~!~!~!!!~!%$#!@$CANCEL@$*%*(!(*&!%^^*)(*&@&@){}|}{:"

Private fInput As frmInput

Public Enum Overwrite
    Yes = 1
    No = 0
    Prompt = 2
End Enum

Public Enum dTransferMode
    Binary = 0
    ASCII = 1
End Enum

Public Const strEncryptionKey = "NJA98ASJAG7S634JAHZHGHK21745758236467KSJ578H4HS61648567Q635766A8365873425JKJASDKJ238ASD852KJKJASDJK5ADSAKJ34WKJASJKAW4598KJSDFKJS"

Public Sub Main()
    Set mFTP = New cFTP
    Set Registry = New RegistryHandler
    Set fInput = New frmInput
    
    Load frmSysTray
    ChangeIcon
    frmSysTray.trayIcon.Visible = True
    frmSysTray.trayIcon.Enabled = True
    
    On Error Resume Next
    If Command() = "/setup" Then
        frmMain.Show
        Exit Sub
    Else
        Call DownloadFiles(, , True, COverwrite(Registry.GetRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP", "Overwrite")))
        frmSysTray.trayIcon.Visible = False
        DoEvents
    End If
    
    Unload frmMain
    Unload frmSysTray
    
    End
    
End Sub

Public Sub mWait()
    Screen.MousePointer = vbHourglass
    
End Sub

Public Sub mOk()
    Screen.MousePointer = vbNormal

End Sub

Public Function COverwrite(sData) As Overwrite
    Select Case CStr(sData)
    Case "Prompt"
        COverwrite = Prompt
    Case "No"
        COverwrite = No
    Case "Yes"
        COverwrite = Yes
    Case Else
    End Select
    
End Function

Public Sub RefreshDirectoryListing()
    Dim Item As cDirItem
    Dim lstX As ListItem
    Dim sAttr As String
    
    mWait
    mFTP.GetDirectoryListing "*.*"
    
    frmDialog.ic.ComboItems.Clear
    frmDialog.lv.ListItems.Clear
    
    Set lstX = frmDialog.lv.ListItems.Add(, , "..")
    
    For Each Item In mFTP.Directory
        sAttr = ""
        With Item
            If .Directory Then
                frmDialog.ic.ComboItems.Add , , Item.Filename
                frmDialog.lv.ListItems.Add , , Item.Filename
            End If
        End With
    Next
    
    For Each Item In mFTP.Directory
        sAttr = ""
        With Item
            If Not .Directory Then
                frmDialog.lv.ListItems.Add , , Item.Filename
            End If
        End With
    Next

    mOk
End Sub

Public Sub DownloadFiles(Optional SpecificServer As String, Optional SpecificFile As String, Optional AutoDownload As Boolean = False, Optional ByVal OverwriteExisting As Overwrite = Prompt)
    On Error Resume Next
    Dim Servers As Variant, Server As Variant, Files As Variant, File As Variant
    Dim sUser As String, sPass As String, sLocal As String, sRemote As String, sServer As String
    
    Servers = Registry.EnumKeys(HKEY_LOCAL_MACHINE, "SOFTWARE\AutoFTP")
    For Each Server In Servers
        Files = Registry.EnumKeys(HKEY_LOCAL_MACHINE, "SOFTWARE\AutoFTP\" & Server)
TryAgain:
        sServer = CStr(Server)
        
        ' Check to see if the specified server is current. If not, skip this one.
        If (SpecificServer <> "") And (sServer <> SpecificServer) Then GoTo NextServer
                    
        Dim sDir As String, LastDL As String
        For Each File In Files
            If Err.Number = 92 Then GoTo NextServer
            sFile = CStr(File)
            If (SpecificFile <> "") And (sFile <> SpecificFile) Then GoTo NextFile

TryFileAgain:
            sLocal = Registry.GetRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP\" & sServer & "\" & sFile, "NewFile")
            sRemote = Registry.GetRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP\" & sServer & "\" & sFile, "Path") & "/" & Registry.GetRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP\" & Server & "\" & File, "Filename")
            If Left$(sRemote, 1) = "/" Then sRemote = Right$(sRemote, Len(sRemote) - 1)
                            
            If AutoDownload Then
                LastDL = Registry.GetRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP\" & sServer & "\" & sFile, "LastDL")
                If IsNothing(LastDL) Then   'This is the initial download
                    Call Registry.WriteRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP\" & sServer & "\" & sFile, "LastDL", Format$(Date, "mm/dd/yyyy"))
                Else                        'This section is used to test if the file should be taken.
                    Select Case Registry.GetRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP\" & sServer & "\" & sFile, "Recur")
                    Case "Daily"
                        If Date > DateAdd("d", 1, LastDL) Then
                            GoTo Proceed
                        Else
                            GoTo NextFile
                        End If
                    Case "Weekly"
                        If Date > DateAdd("ww", 1, LastDL) Then
                            GoTo Proceed
                        Else
                            GoTo NextFile
                        End If
                    Case "Monthly"
                        If Date > DateAdd("m", 1, LastDL) Then
                            GoTo Proceed
                        Else
                            GoTo NextFile
                        End If
                    Case "Yearly"
                        If Date > DateAdd("yyyy", 1, LastDL) Then
                            GoTo Proceed
                        Else
                            GoTo NextFile
                        End If
                    Case "When the computer starts"
                        If Date > LastDL Then
                            GoTo Proceed
                        Else
                            GoTo NextFile
                        End If
                    Case Else
                    
                    End Select
                End If
                
            End If

Proceed:
            If mFTP.Connected = False Then
                sUser = DecryptWithClipper(Registry.GetRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP\" & sServer, "Username"), strEncryptionKey)
                sPass = DecryptWithClipper(Registry.GetRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP\" & sServer, "Password"), strEncryptionKey)
                If (sPass = "") Or (mFTP.GetLastErrorNumber = 12014) Then ' No saved password, or incorrect. Prompt.
                    Set fInput = New frmInput
                    fInput.PasswordChar = "*"
                    fInput.Title = "Enter the Password:"
                    fInput.Caption = "Password Required - " & Server
                    fInput.Show 1
                    If fInput.Value = vbCancelString Then Exit Sub
                    
                    sPass = fInput.Value
                    If sPass = "" Then GoTo NextServer
                    DoEvents
                End If

                If mFTP.OpenConnection(sServer, sUser, sPass) = False Then
                    ' Connection to FTP Server Failed
                    retval = MsgBox("Could not connect to " & sServer & ". Do you wish to try this server again?" & Chr$(13) & Chr$(13) & "Reason: " & mFTP.GetLastErrorMessage, vbExclamation + vbYesNo)
                    If retval = vbNo Then GoTo TryAgain
                End If
                
                ' If the Auto Downloading sequence is engaged, show the balloon telling the user that
                ' download for the server has started.
                If AutoDownload = True Then
                    frmSysTray.trayIcon.BalloonTitle = "AutoFTP v" & App.Major & "." & App.Minor
                    frmSysTray.trayIcon.BalloonText = "Notice: AutoFTP has now started downloading files from the " & sServer & " connection automatically."
                    frmSysTray.trayIcon.BalloonIcon = Info
                    Call frmSysTray.trayIcon.ShowBalloon(5000)
                End If
                
            End If
            
            If mFTP.Connected = True Then
                sDir = Dir(sLocal)
                If sDir = "" Then
                    If Not mFTP.SimpleFTPGetFile(sLocal, sRemote) Then
                        'File Download Failed
                        retval = MsgBox(sRemote & " did not download properly. " & Chr$(13) & "Do you want to try again?" & Chr$(13) & Chr$(13) & mFTP.GetLastErrorMessage, vbYesNo + vbExclamation)
                        If retval = vbYes Then GoTo TryFileAgain
                    End If
                Else
                    Select Case OverwriteExisting
                    Case 1      'Overwrite Always
                        If Not mFTP.SimpleFTPGetFile(sLocal, sRemote) Then
                            'File Download Failed
                            retval = MsgBox(sRemote & " did not download properly. " & Chr$(13) & "Do you want to try again?" & Chr$(13) & Chr$(13) & mFTP.GetLastErrorMessage, vbYesNo + vbExclamation)
                            If retval = vbYes Then GoTo TryFileAgain
                        End If
                        
                    Case 2      'Prompt User
                        If MsgBox(sLocal & " already exists." & Chr$(13) & "Do you want to replace it?", vbExclamation + vbYesNo) = vbYes Then
                            DoEvents
                            If Not mFTP.SimpleFTPGetFile(sLocal, sRemote) Then
                                'File Download Failed
                                retval = MsgBox(sRemote & " did not download properly. " & Chr$(13) & "Do you want to try again?" & Chr$(13) & Chr$(13) & mFTP.GetLastErrorMessage, vbYesNo + vbExclamation)
                                If retval = vbYes Then GoTo TryFileAgain
                            End If
                        End If
                        
                    Case Else   'Overwrite Never
                        GoTo NextFile
                    End Select
                End If
            End If
            
            ' Append the log file with the new download information
            If Registry.GetRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP", "Log") = 1 Then
                Open Registry.GetRegValue(HKEY_LOCAL_MACHINE, "Software\AutoFTP", "LogFile") For Append As #1
                sText = Date & "  " & Time & "  " & AutoDownload & "  " & sServer & "/" & sRemote & "  " & sLocal
                Write #1, sText
                Close #1
            End If
            
            Registry.WriteRegValue HKEY_LOCAL_MACHINE, "Software\AutoFTP\" & sServer & "\" & sFile, "LastDL", CStr(Date)
            
NextFile:
        If mFTP.GetLastErrorNumber > 0 Then mFTP.ResetLastError
        Next File
        
        If mFTP.Connected = True Then mFTP.CloseConnection

NextServer:
    Next Server
    
End Sub

Public Function IsNothing(sCheck As String) As Boolean
    IsNothing = True
    If Len(Trim(sCheck)) > 0 Then IsNothing = False
End Function

Public Function ChangeIcon(Optional iIndex = 37) As Boolean
    ChangeIcon = True
    On Error Resume Next
    Set frmSysTray.trayIcon.Icon = frmSysTray.imgIcons.ListImages(iIndex).Picture
    If Err.Number > 0 Then ChangeIcon = False
    
End Function
